/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pouringwater_jf.comparator;

import java.util.Arrays;
import java.util.Comparator;
import pouringwater_jf.State;

/**
 *
 * @author yare
 */
public class CombCmp implements Comparator<State>{

    public int compare(State t1, State t2) {
        int sum1 = 0;
        int sum2 = 0;
        int count1 = 0;
        int count2 = 0;
        int value1 = 0;
        int value2 = 0;
        
        for (int i = 0; i < t1.instance.itemCount; i++) {
            count1 += (t1.buckets[i] == t1.instance.finalState.buckets[i]) ? 1 : 0;
            count2 += (t2.buckets[i] == t2.instance.finalState.buckets[i]) ? 1 : 0;
            sum1 += Math.abs(t1.buckets[i] - t1.instance.finalState.buckets[i]);
            sum2 += Math.abs(t2.buckets[i] - t2.instance.finalState.buckets[i]);
        }
        int multiplier = (int) Math.floor(t1.instance.getSumCapacities() / (double)t1.instance.itemCount);
        value1 = sum1 - (int)Math.floor(1.8 * multiplier * count1);
        value2 = sum2 - (int)Math.floor(1.8 * multiplier * count2);
        
//        System.out.println(">>comparison: " + value1 + "/" + value2);
//        System.out.println(t1);
//        System.out.println(t2);
//        System.out.println(t1.instance.finalState);
//        
        if (value1 < value2) {
            return -1;
        } else if (value1 > value2){
            return 1;
        }
        return 0;
    }
}
